import std.file;
import std.stdio;

import program : Program;

int main(in string[] args) {
    // shark eval <source>
    if(args.length > 2 && args[1] == "eval") {
        string src = args[2];
        for(size_t i = 3; i < args.length; i++) src ~= args[i];
        return loadSource(src);
    // shark load <file path>
    }else if(args.length > 2 && args[1] == "load") {
        return loadFile(args[2]);
    // shark <file path>
    }else if(args.length > 1) {
        return loadFile(args[1]);
    // Otherwise show usage
    }else {
        writeln("Usage: jungle <file> | jungle load <file> | jungle eval <code>");
        writeln("Example: jungle example.jg");
        return 0;
    }
}

int executeProgram(Program program) {
    write(program.status.toString());
    if(program.status.hasError()) {
        return 1;
    }else {
        program.execute();
        return 0;
    }
}

int loadSource(in string src) {
    return executeProgram(Program.load(src));
}

int loadFile(in string path) {
    string src = void;
    try {
        src = cast(string) read(path);
    }catch(Exception exception) {
        writeln("Failed to load file from path \"", path, "\".");
        return 1;
    }
    return loadSource(src);
}
